//CSE124C Lab 8 Section 4 --- Haibei Zhang
//mytime.cpp
//This class is created in lab3, now reused to test queue

//CSE124C lab3 section4 --- Haibei Zhang
#include "myTime.h"

//Set myTime as hours, minutes, AM(isAM is true) or PM(false)
void myTime::setTime(int h, int m, bool isAm)
{	if (isAm==true)
		{
                if (h==12) t=miliTime(0,m);
		else t=miliTime(h,m);
                }
	else if (h==12) t=miliTime(12,m);
		else t=miliTime(h+12,m);
}

//constructor, if there's no argument, set time to 12:00 AM (see default value in myTime.h)
myTime::myTime(int h, int m, bool isAM)
{
       setTime(h,m,isAM);
}

//Get the military hour
int myTime::get24h()
{       
	return t.getHour();

}

//Convert a positive integer to myTime
void myTime::convertIntToMytime(int i)
{
	int minOfDay=i%(24*60);
	t.setHour(minOfDay/60);
	t.setMinute(minOfDay%60);
}

// output myTime in the format hh:mm AM(PM)
ostream& operator<< (ostream& ostr, myTime& t12)
{	bool isAM; 
	miliTime temp=t12.t;
        if (t12.t.getHour()>12)
			{
                temp.setHour(temp.getHour()-12);
				isAM=false;
			}
	else if(t12.t.getHour()==0)
            {
				temp.setHour(temp.getHour()+12);
				isAM=true;
			}
	else if(t12.t.getHour()==12) isAM=false;
	else isAM=true;

	ostr.fill(' ');
	ostr<<setw(2)<<temp.getHour()<<":";
	ostr.fill('0');
	ostr<<setw(2)<<temp.getMinute()<<(isAM?" AM":" PM");
    return ostr;
}

//overload == operator for two myTime objects
bool operator== (myTime& lhs, myTime& rhs)
{
	return lhs.t==rhs.t;
}

//overload > operator for two myTime objects
bool operator>(myTime& lhs, myTime& rhs)
{
	return lhs.t>rhs.t;
}

//overload < operator for two myTime objects
bool operator<(myTime& lhs, myTime& rhs)
{
	return lhs.t<rhs.t;
}

bool operator<(const myTime& lhs, const myTime& rhs)
{
	return lhs.t<rhs.t;
}