//CSE124C Lab 8 Section 4 --- Haibei Zhang
//main.cpp

#include <time.h>
#include <string>
#include "priority_queue.h"
#include "mytime.h"


int main()
{
	srand( (unsigned)time( NULL ) ); 
	ifstream in("input.txt");
	ofstream out("output.txt");

	//Test 1: 
	//Create an integer queue with 100 random integers ranging from 1 to 100.
	//When the integers are pushed into queue, they are expected to be stored in the ordered "qlist".
	//Print out the qlist, then pop and print each item in the queue until it is empty.
		
	//Define and Populate an integer queue with 100 random integers
	priority_queue<int> myqueue;
	for(int i=0;i<100;i++)
	{
		myqueue.push(rand()%100+1);
	}

	//Print the inner ordered list of myqueue
	out<<"The inner ordered list of myqueue: "<<endl
		<<myqueue<<endl;

	//Print and pop the top of myqueue until it is empty
	out<<"Print and pop the top of myqueue one by one:"<<endl;
	while(!myqueue.empty())
	{
		out<<myqueue.top()<<' ';
		myqueue.pop();
	}
	
	out<<endl<<endl;

	
	//Test 2: 
	//Create a myTime queue with 10 times ranging from 12:00 AM to 11:59 PM.
	//When the times are pushed into queue, they are expected to be stored in the ordered "qlist".
	//Print out the qlist, then pop and print each item in the queue until it is empty.

	//Define and Populate a myTime queue with 10 times
	priority_queue<myTime> myqueue2;
	myqueue2.push(myTime(3,56,true));
	myqueue2.push(myTime(7,3,true));
	myqueue2.push(myTime(12,0,true));
	myqueue2.push(myTime(11,59,false));
	myqueue2.push(myTime(12,0,false));
	myqueue2.push(myTime(12,1,false));
	myqueue2.push(myTime(11,59,true));
	myqueue2.push(myTime(5,32,false));
	myqueue2.push(myTime(5,1,true));
	myqueue2.push(myTime(10,48,false));

	//Print the inner ordered list of myqueue2
	out<<"The inner ordered list of myqueue2: "<<endl
		<<myqueue2<<endl;

	//Print and pop the top of myqueue2 until it is empty
	out<<"Print and pop the top of myqueue2 one by one:"<<endl;
	while(!myqueue2.empty())
	{
		out<<myqueue2.top()<<' ';
		myqueue2.pop();
	}


	return 0;
}