//CSE124C Lab 8 Section 4 --- Haibei Zhang
//mytime.h
//This class is created in lab3, now reused to test queue

//CSE124C lab3 section4 --- Haibei Zhang
#ifndef myTime_h
#define myTime_h

#include "miliTime.h"


class myTime
{
private:
	//An internal representation using military time
	miliTime t;
	
public:
	//constructor, if there's no argument, set time to 12:00 AM
	myTime(int h=12, int m=0, bool isAM=true);
	
	//Set myTime as hours, minutes, AM(isAM is true) or PM(false)
	void setTime(int h, int m, bool isAM);

	//Get the military hour
	int get24h();

	//Convert a positive integer to myTime
	void convertIntToMytime(int i);

	//Overload the == operator for two myTime objects
	friend bool operator==(myTime& lhs, myTime& rhs);

	//Overload the > operator for two myTime objects
	friend bool operator>(myTime& lhs, myTime& rhs);
	
	//Overload the < operator for two myTime objects	
	friend bool operator<(myTime& lhs, myTime& rhs);

	//Overload the < operator for two myTime objects, const version	
	friend bool operator<(const myTime& lhs, const myTime& rhs);
	
	// output myTime in the format hh:mm AM(PM)
	friend ostream& operator<< (ostream& ostr, myTime& t12);

};

#endif //myTime_h